<script lang="ts">
	import { run } from 'svelte/legacy';

	import SelectList from '../../components/SelectList.svelte'
	import TextEntry from '../../components/TextEntry.svelte'
	import { enhance, type SubmitFunction } from '$app/forms'
	import { getWordFromNumber } from '../../helpers'
	import type { PageData } from './$types'
	import Popup from '../../components/Popup.svelte'
	import type { Distance } from '@prisma/client'
	//@ts-ignore
	import { Confetti } from 'svelte-confetti'

	interface Props {
		data: PageData;
	}

	let { data = $bindable() }: Props = $props();

	let distance: string = $state(data.distance || '')
	let comment: string = $state('')
	let date: string = $state(new Date().toISOString().substring(0, 10))
	let selectedItems: string[] = $state(data.routeOptions)
	let canPost: boolean = $state(false)
	let htmlSelectList: SelectList = $state()
	let showPopup = $state(false)
	let popupText: string = $state('')
	let showConfetti: boolean = $state(false)
	
	run(() => {
		canPost = selectedItems?.length > 0 && !isNaN(Number(distance)) && !!distance
	});
	let postText = $derived(canPost
		? `Post ${distance} km to ${getWordFromNumber(selectedItems.length)} route${selectedItems.length !== 1 ? 's' : ''}`
		: 'Enter a distance and at least one route')

	function fadePopup(message: string, confetti = false) {
		popupText = message
		showPopup = true
		setTimeout(() => (showPopup = false), 5000)
		if (confetti) {
			showConfetti = true
			setTimeout(() => (showConfetti = false), 5000)
		}
	}

	const resetForm: SubmitFunction = (input) => {
		return async ({ result, update }) => {
			const added = (result as any).data.distances as (Distance & { routeName: string; iconUrl: string })[]
			const message = (result as any).data.message
			const confetti = (result as any).data.confetti

			data.history.splice(0, 0, ...added)
			data.history = data.history
			date = new Date().toISOString().substring(0, 10)
			await update()
			htmlSelectList.resetSelection()
			fadePopup(message, confetti)
		}
	}
</script>

<form method="POST" action="?/post" use:enhance={resetForm}>
	<TextEntry
		bind:value={distance}
		name="distance"
		type="numeric"
		title="Distance"
		description="How far did you travel in Kilometers (km) for this activity?"
	/>

	<TextEntry
		bind:value={comment}
		name="comment"
		type="text"
		title="Comment"
		description="Would you like to comment on this activity? (optional)"
	/>

	<TextEntry
		bind:value={date}
		name="date"
		type="date"
		title="Date"
		description="If this activity was in the past, specify the date here"
	/>

	<SelectList
		bind:this={htmlSelectList}
		text="View Routes..."
		name="routes"
		title="Route"
		description="Which route(s) do you want to make this progress on?"
		bind:selectedItems
		items={data.routeOptions}
	/>

	<button class:disabled={!canPost} disabled={!canPost} name="button" value="test">
		{postText}
	</button>
</form>

{#if showPopup}
	<Popup text={popupText} textRainbow={true} />
{/if}

{#if showConfetti}
	<div
		style="
position: fixed;
bottom: 0px;
height: 0vh;
width: 100vw;
display: flex;
justify-content: center;
pointer-events: none;"
	>
		<Confetti x={[-1, 1]} y={[0.25, 5]} xSpread="0.01" />
	</div>
{/if}

<style>
	button {
		background-color: var(--accentColour);
		border: none;
		border-radius: 0.25rem;
		display: inline-block;
		margin: 1rem;
		font-family: Quicksand;
		font-weight: 500;
		padding-left: 1rem;
		padding-right: 1rem;
		padding-top: 0.5rem;
		padding-bottom: 0.5rem;
		font-size: 1.2rem;
	}

	button.disabled {
		color: #ffffff55;
		background-color: #ffffff05;
	}

	form {
		margin-bottom: 3rem;
	}
</style>
